/**
 * Created by wWX396118 on 2018/4/27.
 */
var stringMap = {
    "attachment_size_limit":"附件总大小超过单次传输4M限制，上传失败",
    "self_zone_attachment_size_limit":"附件总大小超过20M限制，上传失败",
    "problem_description_limit1":"问题描述不能为空或空格",
    "problem_description_limit2":"问题描述只能包含汉字、英文大小写字母、数字、空格、标点和部分特殊字符",
    "problem_description_limit3":"问题描述最多能输入500个字符",
    "contact_information_limit1":"联系方式最多能输入50个字符",
    "contact_information_limit2":"联系方式只能包含汉字、英文大小写字母、数字、空格、标点和部分特殊字符",
    "submit_feedback_success":"提交成功！感谢您的宝贵意见",
    "add_member_success":"成员添加成功",
    "add_member_fail1":"您的免费额度不足，成员添加失败",
    "add_member_fail2":"成员添加失败",
    "business_account_limit1":"企业账户不能为空",
    "business_account_limit2":"企业账户不能少于5个字符",
    "business_account_limit3":"企业账户不能超过32个字符",
    "business_account_limit4":"企业账户只能输入数字、英文大小写、“-”和“_”",
    "business_account_limit5":"不能添加本企业账户",
    "invite_fail1":"需要被邀请企业账户同意授权",
    "invite_fail2":"该企业用户不存在或不是华为云DevCloud用户",
    "user_name_limit1":"用户名不能少于5个字符",
    "user_name_limit2":"用户名不能超过32个字符",
    "user_name_limit3":"用户名只能输入数字、英文大小写、“-”和“_”",
    "user_not_exist":"该用户不存在",
    "already_invite":"已邀请该企业用户，请等待用户接受邀请",
    "go_back_confirm":"数据还未保存，确定要离开？",
    "project_name_limit1":"项目名称不能为空",
    "project_name_limit2":"项目名称只能包含汉字、英文大小写、数字及部分特殊字符",
    "project_name_limit3":"项目名称不能少于3个字符",
    "project_name_limit4":"项目名称不能超过128个字符",
    "project_description_limit1":"项目描述不能超过1024个字符",
    "project_description_limit2":"项目描述只能包含汉字、英文大小写、数字及部分特殊字符",
    "project_update_success":"项目更新成功",
    "user_frozen":"该租户已被冻结",
    "project_create_success":"项目新建成功",
    "project_name_duplicate":"项目名称已存在",
    "issue_not_found":"没有匹配的工作项",
    "project_not_found":"没有匹配的项目",
    "member_not_found":"没有匹配的人员",
    "iteration_not_found":"没有匹配的迭代",
    "module_not_found":"没有匹配的模块",
    "domain_not_found":"没有匹配的领域",
    "option_not_found":"没有匹配的选项",
    "no_member":"没有可添加的成员",
    "no_iteration":"该项目还未添加迭代，请到项目设置页添加",
    "no_module":"该项目还未添加模块，请到项目设置页添加",
    "no_domain":"该项目还未添加领域，请到项目设置页添加",
    "iteration_name_limit1":"迭代名称不能为空",
    "iteration_name_limit2":"迭代名称只能包含汉字、英文大小写字母、数字、小数点和连字符",
    "iteration_name_limit3":"迭代名称不能超过60个字符",
    "iteration_description_limit1":"迭代描述不能超过255个字符",
    "iteration_description_limit2":"迭代描述只能包含汉字、英文大小写、数字及部分特殊字符",
    "iteration_name_duplicate":"迭代名称已存在",
    "iteration_create_success":"迭代新建成功",
    "iteration_update_success":"迭代更新成功",
    "module_update_success":"模块更新成功",
    "iteration_overlap":"迭代日期与已有迭代重叠",
    "module_name_limit1":"模块名称不能为空",
    "module_name_limit2":"模块名称只能包含汉字、英文大小写字母、数字、下划线和连字符",
    "module_name_limit3":"模块名称不能超过30个字符",
    "module_description_limit1":"模块描述不能超过255个字符",
    "module_person_limit":"请选择处理人",
    "module_description_limit2":"模块描述只能包含汉字、英文大小写、数字及部分特殊字符",
    "module_create_success":"模块新建成功",
    "module_name_duplicate":"模块名称已存在",
    "date_limit1":"开始日期不能晚于结束日期",
    "date_limit2":"结束日期不能早于开始日期",
    "domain_delete_fail":"无法删除有工作项的领域",
    "module_delete_fail":"无法删除有工作项的模块",
    "iteration_delete_fail":"无法删除有工作项的迭代",
    "work_item_insertion_fail1":"该项目所属企业用户的系统管理员账户余额不足，无法新建工作项",
    "work_item_insertion_fail2":"该项目所属企业用户的系统管理员没有开通项目管理服务，无法新建工作项",
    "work_item_title_limit1":"工作项标题不能为空",
    "work_item_title_limit2":"工作项标题最大长度不超过128个字符",
    "work_item_title_limit3":"工作项标题只能包含汉字、英文大小写字母、数字、空格、标点和部分特殊字符",
    "work_item_title_limit4":"工作项描述不能超过10000个字符",
    "work_item_title_limit5":"工作项描述只能包含汉字、英文大小写字母、数字、空格、标点和部分特殊字符",
    "work_item_create_success":"工作项新建成功",
    "work_item_attachment_add_fail":"工作项附件添加失败",
    "work_item_migrate_fail1":"该项目所属企业用户的系统管理员账户余额不足，无法迁移",
    "work_item_migrate_fail2":"该项目所属企业用户的系统管理员没有开通项目管理服务，无法迁移",
    "date_update":"迭代修改后计划时间也会自动调整",
    "tag_limit1":"最多添加10个标签",
    "tag_limit2":"标签已存在",
    "tag_limit3":"标签只能包含汉字、英文大小写、数字及部分特殊字符",
    "tag_limit4":"标签不能超过25个字符"
};
