var uEventListeners = {};

function __uPublicBackButtonOnClick() {
    uEventListeners["publicBackButtonClick"]();
}

function __uPublicEditButtonOnClick() {
    uEventListeners["publicEditButtonClick"]();
}

function __uPublicDeletePositiveButtonOnClick() {
    uEventListeners["publicDeletePositiveButtonClick"]();
}

function __uPublicSearchOnSubmit(searchString) {
    uEventListeners["publicSearchSubmit"](searchString);
}

function __uPublicCompleteButtonOnClick() {
    uEventListeners["publicCompleteButtonClick"]();
}

function __uShowMainPage() {
    uEventListeners["ShowMainPage"]();
}

function __workItemUpdateButtonClick() {
    uEventListeners["workItemUpdateButtonClick"]();
}

function __uSaveWorkItemTag() {
    uEventListeners["saveWorkItemTag"]();
}

function __uOpenSingleAttachmentFinished(src,duration,fileSize) {
    uEventListeners["openSingleAttachmentFinished"](src,duration,fileSize);
}

function __uOpenMultipleAttachmentFinished(srcGroup) {
    uEventListeners["openMultipleAttachmentFinished"](srcGroup);
}

function __uChooseDateFinished(date) {
    uEventListeners["chooseDateFinished"](date);
}

function __uVoicePlayFinished() {
    uEventListeners["voicePlayFinished"]();
}

function __uTagColorSelected(color) {
    uEventListeners["tagColorSelected"](color);
}

function __uConfirmDialogConfirmed() {
    uEventListeners["confirmDialogConfirmed"]();
}

function __uSendFeedback(){
    uEventListeners["sendFeedback"]();
}

function __updateWorkItem() {
    uEventListeners["updateWorkItem"]();
}
function __updateWorkInfoSubject(subject) {
    console.log("__updateWorkInfoSubject");
    uEventListeners["updateWorkInfoSubject"](subject);
}
function __updateProject() {
    uEventListeners["updateProject"]();
}

function __stopRecord() {
    uEventListeners["stopRecord"]();
}

function __uSetKeyboardHeight(height) {
    uEventListeners["setKeyboardHeight"](height);
}

function __uCheckData() {
    uEventListeners["checkData"]();
}

function __uUpdateData() {
    uEventListeners["updateData"]();
}

function __uUpdateAttachment(args) {
    uEventListeners["updateAttachment"](args);
}

function uSetUpdateDataListener(clickFunction) {
    uEventListeners["updateData"] = clickFunction;
}

function uSetCheckDataListener(clickFunction) {
    uEventListeners["checkData"] = clickFunction;
}

function uSetUpdateAttachmentListener(clickFunction) {
    uEventListeners["updateAttachment"] = clickFunction;
}

function uSetKeyboardHeightListener(clickFunction) {
    uEventListeners["setKeyboardHeight"] = clickFunction;
}

function uSetStopRecordListener(clickFunction) {
    uEventListeners["stopRecord"] = clickFunction;
}

function uSetUpdateWorkItemListener(clickFunction) {
    uEventListeners["updateWorkItem"] = clickFunction;
}
function uSetupdateWorkInfoSubjectListener(clickFunction) {
    uEventListeners["updateWorkInfoSubject"] = clickFunction;
}
function uSetUpdateProjectListener(clickFunction) {
    uEventListeners["updateProject"] = clickFunction;
}

function uSetPublicBackButtonClickListener(clickFunction) {
    uEventListeners["publicBackButtonClick"] = clickFunction;
}

function uSetPublicEditButtonClickListener(clickFunction) {
    uEventListeners["publicEditButtonClick"] = clickFunction;
}

function uSetPublicDeletePositiveButtonClickListener(clickFunction) {
    uEventListeners["publicDeletePositiveButtonClick"] = clickFunction;
}

function uSetPublicSearchOnSubmitListener(clickFunction) {
    uEventListeners["publicSearchOnSubmitListener"] = clickFunction;
}

function uSetPublicCompleteButtonClickListener(clickFunction) {
    uEventListeners["publicCompleteButtonClick"] = clickFunction;
}

function uSetShowMainPageListener(clickFunction) {
    uEventListeners["ShowMainPage"] = clickFunction;
}

function uSetSaveWorkItemTagButtonClickListener(clickFunction) {
    uEventListeners["saveWorkItemTag"] = clickFunction;
}

function uSetOpenSingleAttachmentFinishedListener(clickFunction) {
    uEventListeners["openSingleAttachmentFinished"] = clickFunction;
}

function uSetOpenMultipleAttachmentFinishedListener(clickFunction) {
    uEventListeners["openMultipleAttachmentFinished"] = clickFunction;
}

function uSetChooseDateFinishedListener(clickFunction) {
    uEventListeners["chooseDateFinished"] = clickFunction;
}

function uSetVoicePlayFinishedListener(clickFunction) {
    uEventListeners["voicePlayFinished"] = clickFunction;
}

function uSetTagColorSelectedListener(clickFunction) {
    uEventListeners["tagColorSelected"] = clickFunction;
}

function uSetConfirmDialogConfirmedListener(clickFunction) {
    uEventListeners["confirmDialogConfirmed"] = clickFunction;
}

function uSetSendFeedbackListener(clickFunction){
    uEventListeners["sendFeedback"] = clickFunction;
}


function uSet(key, value) {
    if (typeof (Android) !== "undefined") {
        Android.setUserInfo(key, value+"");
    }
}

function uSetWorkItemInfo(projectUUID, workItemType,projectType) {
    if (typeof (Android) !== "undefined") {
        Android.setWorkItemInfo(projectUUID, workItemType,projectType);
    }
}

function uGetWorkItemInfo() {
    if (typeof (Android) !== "undefined") {
        return Android.getWorkItemInfo();
    }
    return "";
}

function uGetLog() {
    if (typeof (Android) !== "undefined") {
        return Android.getLog();
    }
    return "";
}
function uSetFilterParams(filterParams) {
    if (typeof (Android) !== "undefined") {
        Android.setFilterParams(filterParams);
    }
}

function uHideKeyboard() {
    if (typeof (Android) !== "undefined") {
        Android.hideKeyboard();
    }
}

function uGetFilterParams() {
    if (typeof (Android) !== "undefined") {
        return Android.getFilterParams();
    }
    return "";
}

function uSetWorkItemDetail(workItemDetail) {
    if (typeof (Android) !== "undefined") {
        Android.setWorkItemDetail(workItemDetail);
    }
}

function uGet(key) {
    if (typeof (Android) !== "undefined") {
        return Android.getUserInfo(key);
    }
    return "";
}

function uShowSelf() {
    if (typeof (Android) !== "undefined") {
        return Android.showWebView();
    }
}

function uAddCallback() {
    if (typeof (Android) !== "undefined") {
        return Android.addCallback();
    }
}

function uShowDeleteButton() {
    if (typeof (Android) !== "undefined") {
        return Android.showDeleteButton();
    }
}

function uGetPhotoPath(imageId) {
    return "../../theme/image/addmember-userphoto.png";
}

function uShowAlertDialog(message) {
    if (typeof (Android) !== "undefined") {
        Android.showAlertDialog(message);
    }
}

function uShowConformDialog(message) {
    if (typeof (Android) !== "undefined") {
        Android.showConfirmDialog(message);
    }
}

function uTakePicture() {
    if (typeof (Android) !== "undefined") {
        Android.takePicture();
    }
}

function uGetImageFromAlbum() {
    if (typeof (Android) !== "undefined") {
        Android.getImageFromAlbum();
    }
}

function uGetFileFromPhone() {
    if (typeof (Android) !== "undefined") {
        Android.chooseFile();
    }
}

function uStartAudioRecorder() {
    if (typeof (Android) !== "undefined") {
        Android.startAudioRecorder();
    }
}

function uStopAudioRecorder() {
    if (typeof (Android) !== "undefined") {
        Android.stopAudioRecorder();
    }
}

function uStartPlayingAudio(fileName) {
    if (typeof (Android) !== "undefined") {
        Android.startPlayingAudio(fileName);
    }
}

function uSetData() {
    if (typeof (Android) !== "undefined") {
        Android.setData();
    }
}

function uHidePublicAddButton() {
    if (typeof (Android) !== "undefined") {
        Android.hidePublicAddButton();
    }
}
function uShowPhotoDialog() {
    if (typeof (Android) !== "undefined") {
        return Android.showPhotoDialog();
    }
}
function uStopPlayingAudio() {
    if (typeof (Android) !== "undefined") {
        return Android.stopPlayingAudio();
    }
}
function uShowTagColorDialog (color) {
    if (typeof (Android) !== "undefined") {
        return Android.showTagColorDialog(color);
    }
}

function uShowLogoutDialog() {
    if (typeof(Android) !== "undefined"){
        return Android.showLogoutDialog();
    }
}

function uFinishCurrentPage() {
    if (typeof(Android) !== "undefined"){
        return Android.finish();
    }
}

function uPrintFileOff() {
    if (typeof(Android) !== "undefined"){
        return Android.printFileOff();
    }
}

function uPrintFileOn() {
    if (typeof(Android) !== "undefined"){
        return Android.printFileOn();
    }
}

function uSetSaveButtonClickable(isSaveButtonClickable) {
    if (typeof(Android) !== "undefined") {
        return Android.setSaveButtonClickable(isSaveButtonClickable);
    }
}

function uSetRegion(region) {
    if (typeof(Android) !== "undefined"){
        return Android.setRegion(region);
    }
}

function uGetRegion() {
    if (typeof(Android) !== "undefined"){
        return Android.getRegion();
    }
}
function uGetAppVersion() {
    if (typeof(Android) !== "undefined"){
        return Android.getAppVersionName();
    }
}
function uShowAttachment(fileList, index,fileType) {
    if (typeof (Android) !== "undefined") {
        Android.showAttachment(JSON.stringify(fileList), index,fileType);
    }
}

function uShowToast(message) {
    if (typeof (Android) !== "undefined") {
        Android.showToast(message);
    }
}

function uIsFileExist(src) {
    if (typeof (Android) !== "undefined") {
        return Android.isFileExist(src);
    }
}

function uShowSubPage() {
    if (typeof (Android) !== "undefined") {
        return Android.showSubPage();
    }
}

function uShowPage(index) {
    if (typeof (Android) !== "undefined") {
        return Android.showPage(index);
    }
}

function uShowLoadingPage() {
    if (typeof (Android) !== "undefined") {
        return Android.showLoadingPage();
    }
}

function uHideLoadingPage() {
    if (typeof (Android) !== "undefined") {
        return Android.hideLoadingPage();
    }
}

function uShowProjectEditionPage() {
    if (typeof (Android) !== "undefined") {
        return Android.showProjectEditionPage();
    }
}

function uShowMemberPage() {
    if (typeof (Android) !== "undefined") {
        return Android.showMemberPage();
    }
}

function uShowQrCodePage() {
    if (typeof (Android) !== "undefined") {
        return Android.showQrCodePage();
    }
}

function uShowAuthorityPage() {
    if (typeof (Android) !== "undefined") {
        return Android.showAuthorityPage();
    }
}
function uShowProjectIterationPage() {
    if (typeof (Android) !== "undefined") {
        return Android.showProjectIterationPage();
    }
}
function uShowProjectModulePage() {
    if (typeof (Android) !== "undefined") {
        return Android.showProjectModulePage();
    }
}
function uShowProjectFieldPage() {
    if (typeof (Android) !== "undefined") {
        return Android.showProjectFieldPage();
    }
}

function uGoToProject(project_uuid, project_type, project_subject, type) {
    if (typeof (Android) !== "undefined") {
        return Android.goToProject(project_uuid,project_type,project_subject, type);
    }
}

function formatDateTime(time, format) {
    var t = new Date(time);
    var tf = function (i) {
        return (i < 10 ? '0' : '') + i
    };
    return format.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
        switch (a) {
            case 'yyyy':
                return tf(t.getFullYear());
                break;
            case 'MM':
                return tf(t.getMonth() + 1);
                break;
            case 'mm':
                return tf(t.getMinutes());
                break;
            case 'dd':
                return tf(t.getDate());
                break;
            case 'HH':
                return tf(t.getHours());
                break;
            case 'ss':
                return tf(t.getSeconds());
                break;
        }
    })
}

var ROLE = {
    "CREATOR": -1,
    "MANAGER": 3,
    "DEVELOPER": 4,
    "TESTMANAGER": 5,
    "TESTER": 6,
    "Viewer": 7
};

//var ZONE_NORTHEAST = 0;
//var ZONE_NORTH = 1;
//var ZONE_EAST = 2;
//var ZONE_SOUTH = 3;
//var ZONE_SELF = 4;
//var ZONE_NORTH_4 = 5;
//var ZONE_EAST_1= 6;

var colorIdMap = {
    1: '#4fc1e9',
    2: '#a0d468',
    3: '#f6bb42',
    4: '#ac92ec',
    5: '#ec87c0',
    6: '#fa9977',
    7: '#5d9cec',
    8: '#48cfad',
    9: '#aab2bd'
};

var colorIdReverseMap = {
    '#4fc1e9': 1,
    '#a0d468': 2,
    '#f6bb42': 3,
    '#ac92ec': 4,
    '#ec87c0': 5,
    '#fa9977': 6,
    '#5d9cec': 7,
    '#48cfad': 8,
    '#aab2bd': 9
};

var UPLOAD_STATES = {
    "DONE":0,
    "DOING": 1,
    "FAILED": 2,
    "TIMEOUT": 3
};

var DOWNLOAD_STATES = {
    "DONE":0,
    "DOING": 1,
    "TODO": 2
};
function uqrshare(base64,projectUUId,qrCodeUrl){
  if (typeof (Android) !== "undefined") {
        return Android.showShareDialog(base64,projectUUId,qrCodeUrl);
    }
}
function usavepicture(base64,projectUUId){
if (typeof (Android) !== "undefined") {
        return Android.savePicture(base64,projectUUId);
    }
}
function uJumpPrefix(subject){
if (typeof (Android) !== "undefined") {
        return Android.jumpPrefix(subject);
    }
}
function uPrivacyStatement(){
if (typeof (Android) !== "undefined") {
        return Android.PrivacyStatement();
    }
}
function uOpenSource(){
    if (typeof (Android) !== "undefined") {
            return Android.openSource();
        }
    }

function uGetZoneHttpHost(){
if (typeof (Android) !== "undefined") {
    return Android.getZoneHttpHost();
    }
    return "";

}
function uGetCurrentZone(){
if (typeof (Android) !== "undefined") {
    return Android.getCurrentZone();
    }
    return "";

}


function uIsSelfRegion(){
if (typeof (Android) !== "undefined") {
    return Android.isSelfRegion();
    }
    return false;
}


function uJoinClassSuccess(){
if (typeof (Android) !== "undefined") {
    return Android.joinClassSuccess();
    }
    return "";

}
function uJoinJobSuccess(){
if (typeof (Android) !== "undefined") {
    return Android.joinJobSuccess();
    }
    return "";

}
function uGoWorkItemList(name,projectUUID,type){
if (typeof (Android) !== "undefined") {
    return Android.goWorkItemList(name,projectUUID,type);
    }
    return "";

}
function uShowProjectDelete(){
if (typeof (Android) !== "undefined") {
    return Android.showProjectDelete();
    }
    return "";

}
function uGoCreateProjectIteration(){
if (typeof (Android) !== "undefined") {
    return Android.goCreateProjectIteration();
    }
    return "";

}
function uGoProjectIterationDetail(){
if (typeof (Android) !== "undefined") {
    return Android.goProjectIterationDetail();
    }
    return "";

}
function uGoCreateProjectModule(){
if (typeof (Android) !== "undefined") {
    return Android.goCreateProjectModule();
    }
    return "";

}
function uGoProjectModuleDetail(){
if (typeof (Android) !== "undefined") {
    return Android.goProjectModuleDetail();
    }
    return "";

}
function uDeleteProject(){
if (typeof (Android) !== "undefined") {
    return Android.deleteProject();
    }
    return "";

}
function __updateProjectIteration() {
    uEventListeners["getIterations"]();
}
function uSetGetIterationsListener(clickFunction) {
    uEventListeners["getIterations"] = clickFunction;
}
function __updateProjectModules() {
    uEventListeners["getModules"]();
}
function uSetGetModuleListener(clickFunction) {
    uEventListeners["getModules"] = clickFunction;
}
function __deleteProjectModule() {
    uEventListeners["deleteModule"]();
}
function uSetdeleteModuleListener(clickFunction) {
    uEventListeners["deleteModule"] = clickFunction;
}
function __deleteProjectIteration() {
    uEventListeners["deleteIteration"]();
}
function uSetdeleteIterationListener(clickFunction) {
    uEventListeners["deleteIteration"] = clickFunction;
}
function uGoTitlePage(){
if (typeof (Android) !== "undefined") {
    return Android.goTitlePage();
    }
    return "";

}
function uGoDesPage(){
if (typeof (Android) !== "undefined") {
    return Android.goDesPage();
    }
    return "";

}
function uGoTitlePageWithStr(titleStr){
if (typeof (Android) !== "undefined") {
    return Android.goTitlePageWithStr(titleStr);
    }
    return "";

}
function uGoDesPageWithStr(desStr) {
    if (typeof (Android) !== "undefined") {
        return Android.goDesPageWithStr(desStr);
    }
    return "";
}

function uHideLog() {
    if (typeof (Android) !== "undefined") {
        Android.jsHideLog();
    }
}

function uHideAtSomeone() {
    if (typeof (Android) !== "undefined") {
        Android.jsAtSomeone();
    }
}

function __updateIterationTitle(titleStr) {
    uEventListeners["updateIterationTitle"](titleStr);
}
function updateIterationTitleListener(clickFunction) {
    uEventListeners["updateIterationTitle"] = clickFunction;
}
function __updateIterationDes(desStr) {
    uEventListeners["updateIterationDes"](desStr);
}
function updateIterationDesListener(clickFunction) {
    uEventListeners["updateIterationDes"] = clickFunction;
}