window.onload = function () {
    var projectUUId = uGet("projectUUId");
    var vm = new Vue({
        el: '#view-container',
        data: {
            defaultFilter: [
                {name: '所有工作项', checked: true},
                {name: '我的工作项', checked: false},
                {name: '未关闭的', checked: false},
                {name: '已关闭的', checked: false},
                {name: '我关注的', checked: false},
                {name: '我创建的', checked: false},
                {name: '我处理过的', checked: false}

            ],
            selfDefineFilter: [],
            filterList: []
        },

        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function() {
                self.goBack();
            })
            hGetIssueFilter({
                projectId: projectUUId
            }, function (data) {
                uShowSelf();
                self.filterList = self.defaultFilter;
                self.selfDefineFilter = data.result.result.queries;
                for (var i = 0; i < self.selfDefineFilter.length; i++) {
                    self.selfDefineFilter[i].checked = false;
                    self.filterList.push(self.selfDefineFilter[i]);
                }
            });
        },

        methods: {
            checkItem: function (filter) {
                for (var i = 0; i < this.filterList.length; i++) {
                    this.filterList[i].checked = false;
                }
                filter.checked = true;
                this.goBack();
            },
            goBack: function() {
                rWorkItem(projectUUId);
            }
        }
    });
};
