window.onload = function () {
    var isSaving = false;
    var listKey = "";
    var project_uuid = uGet("project_uuid");
    var dueDate = uGet("dueDate");
    var startDate = uGet("startDate");
    var project_uuid = uGet("project_uuid");
    var mIteration = uGet("iteration");
    var mModule = uGet("module");
    var user_id = uGet("user_id");
    var newIterationName;
    var newIterationDescription;
    var searchHintList = {
        'project': [stringMap.project_not_found],
        'assigner': [stringMap.member_not_found],
        'milestone': [stringMap.iteration_not_found, stringMap.no_iteration],
        'module': [stringMap.module_not_found, stringMap.no_module],
        'domain': [stringMap.domain_not_found, stringMap.no_domain]
    };

    var iterationtitlePattern = /^([\u4E00-\u9FA5]|[A-Za-z0-9\-.])*$/;
    var moduletitlePattern = /^[a-zA-Z0-9\u4E00-\u9FA5\-_]+$/;
    var vm = new Vue({
        el: '#view-container',
        data: {
            createprojectiteration: {
                iterationName: "",
                iterationDes: "",
            },
            errorStatus: {
                "iterationName": false,
                "iterationDes": false
            },
            dueDate: dueDate,
            startDate: startDate,
            iteration: mIteration,
            module: mModule,
            moduleName: "",
            owner: "",
            currentInfo: [],
        },
        watch: {
            createprojectiteration: {
                handler: function (val, oldVal) {
                    var subject = this.createprojectiteration.iterationName;
                    if (subject.replace(/\s/g, "") != "") {
                        uSetSaveButtonClickable("true");
                    } else {
                        uSetSaveButtonClickable("false");
                    }
                },
                deep: true
            }
        },
        created: function () {
            self = this;

            this.$nextTick(function () {
                uShowSelf();
            });
            uSetConfirmDialogConfirmedListener(function () {
                self.confirmBack();
            });
        },
        mounted: function () {
            var self = this;
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
            uSetPublicCompleteButtonClickListener(function () {
                self.save();
            });
            uSetChooseDateFinishedListener(function (date) {
                self.chooseDate(date);
            });
            updateIterationTitleListener(function (titleStr) {
                console.log(titleStr);
                self.createprojectiteration.iterationName = titleStr;
                if (self.module === 'true') {
                    var module_name_input = document.getElementById("module_name_input");
                    module_name_input.innerHTML = self.createprojectiteration.iterationName;
                    module_name_input.setAttribute('style', 'color: #333333');
                    if ($('#module_name_input').height() > 170) {
                        module_name_input.setAttribute("class", "create_iteration_module_name_text")
                    }
                } else if (self.iteration = 'true') {
                    var iteration_name_input = document.getElementById("iteration_name_input");
                    iteration_name_input.innerHTML = self.createprojectiteration.iterationName;
                    iteration_name_input.setAttribute('style', 'color: #333333');
                    if ($('#iteration_name_input').height() > 170) {
                        iteration_name_input.setAttribute("class", "create_iteration_module_name_text")
                    }
                }

            });
            updateIterationDesListener(function (desStr) {
                self.createprojectiteration.iterationDes = desStr;
                var module_description_input = document.getElementById("module_description_input");
                if (self.module == 'true') {
                    if (self.createprojectiteration.iterationDes == "") {
                        module_description_input.setAttribute("class", "create_iteration_module_name_hint_des")
                        $('#module_description_input').html("输入模块描述");
                    } else {
                        module_description_input.innerHTML = self.createprojectiteration.iterationDes;
                        if ($('#module_description_input').height() > 131) {
                            module_description_input.setAttribute("class", "create_iteration_module_name_des")
                        }
                        if ($('#module_description_input').height() > 245) {
                            var text = $('#module_description_input').html() + '...';
                            while ($('#module_description_input').height() > 245) {
                                text = text.substr(0, text.length - 4) + '...';
                                $('#module_description_input').html(text);
                            }
                        }
                    }

                } else if (self.iteration) {
                    var iteration_description_input = document.getElementById("iteration_description_input");

                    if (self.createprojectiteration.iterationDes == "") {
                        iteration_description_input.setAttribute("class", "create_iteration_module_name_hint_des")
                        $('#iteration_description_input').html("输入迭代描述");

                    } else {
                        iteration_description_input.innerHTML = self.createprojectiteration.iterationDes;
                        if ($('#iteration_description_input').height() > 131) {
                            iteration_description_input.setAttribute("class", "create_iteration_module_name_des")
                        }
                        if ($('#iteration_description_input').height() > 245) {
                            var text = $('#iteration_description_input').html() + '...';
                            while ($('#iteration_description_input').height() > 245) {
                                text = text.substr(0, text.length - 4) + '...';
                                $('#iteration_description_input').html(text);
                                console.log($('#iteration_description_input').height());
                                console.log(text);
                            }
                        }
                    }
                }

            });
            uSetUpdateWorkItemListener(function () {
                self.updateWorkItem();
            });
            if (mModule == "true") {
                uShowLoadingPage();
                self.getUserListByProjectId();
            }
            uSetSaveButtonClickable("false");
        },
        filters: {
            formatDate: function (time) {
                var t = new Date(time);
                var tf = function (i) {
                    return (i < 10 ? '0' : '') + i
                };
                return 'yyyy-MM-dd'.replace(/yyyy|MM|dd|HH|mm|ss/g, function (a) {
                    switch (a) {
                        case 'yyyy':
                            return tf(t.getFullYear());
                            break;
                        case 'MM':
                            return tf(t.getMonth() + 1);
                            break;
                        case 'mm':
                            return tf(t.getMinutes());
                            break;
                        case 'dd':
                            return tf(t.getDate());
                            break;
                        case 'HH':
                            return tf(t.getHours());
                            break;
                        case 'ss':
                            return tf(t.getSeconds());
                            break;
                    }
                })
            }
        },
        methods: {
            confirmBack: function () {
                uHideLoadingPage();
                uFinishCurrentPage();
            },
            goBack: function () {
                var subject = this.createprojectiteration.iterationName;
                var des = this.createprojectiteration.iterationDes;
                if (subject.replace(/\s/g, "") != "" || des.replace(/\s/g, "") != "") {
                    uShowConformDialog(stringMap.go_back_confirm);
                } else {
                    uHideLoadingPage();
                    uFinishCurrentPage();
                }
            },
            showDatePicker: function (flag) {
                this.startDatePicker = flag;
                uSetData();
            },
            validateIteration: function () {
                var newIterationName = this.createprojectiteration.iterationName;
                var newIterationDescription = this.createprojectiteration.iterationDes;
                this.errorStatus.iterationName = false;
                this.errorStatus.iterationDes = false;
                if (newIterationName == "") {
                    uShowToast(stringMap.iteration_name_limit1);
                    this.errorHintMessage = "迭代名称不能为空";
                    this.errorStatus.iterationName = true;
                } else if ((!(newIterationName.match(iterationtitlePattern)))) {
                    uShowToast(stringMap.iteration_name_limit2);
                    this.errorHintMessage = "迭代名称输入不合法";
                    this.errorStatus.iterationName = true;
                } else if (newIterationName.length > 60) {
                    uShowToast(stringMap.iteration_name_limit3);
                    this.errorHintMessage = "迭代名称不能超过60个字符";
                    this.errorStatus.iterationName = true;
                } else if (newIterationDescription.length > 255) {
                    uShowToast(stringMap.iteration_description_limit1);
                    this.errorHintMessage = "迭代描述不能超过255个字符";
                    this.errorStatus.iterationDes = true;
                } else {
                    this.errorHintMessage = "";
                    return true;
                }
                return false;
            },

            save: function () {
                self = this;
                if (mIteration == "true") {
                    var newIterationName = this.createprojectiteration.iterationName.replace(/(^\s*)|(\s*$)/g, "");
                    var newIterationDescription = this.createprojectiteration.iterationDes.replace(/(^\s*)|(\s*$)/g, "");
                    var self = this;
                    self.createProjectIteration(newIterationName, newIterationDescription);

                }
                if (mModule == "true") {
                    newIterationName = this.createprojectiteration.iterationName.replace(/(^\s*)|(\s*$)/g, "");
                    newIterationDescription = this.createprojectiteration.iterationDes.replace(/(^\s*)|(\s*$)/g, "");
                    self.addModule(newIterationName, newIterationDescription);

                }

            },
            createProjectIteration: function (name, des) {
                self = this;
                if (isSaving) {
                    return;
                }

                var newIterationName = this.createprojectiteration.iterationName;
                var newIterationDescription = this.createprojectiteration.iterationDes;
                this.errorStatus.iterationName = false;
                this.errorStatus.iterationDes = false;
                if (newIterationName == "") {
                    uShowToast(stringMap.iteration_name_limit1);
                    this.errorHintMessage = "迭代名称不能为空";
                    this.errorStatus.iterationName = true;
                } else if ((!(newIterationName.match(iterationtitlePattern)))) {
                    uShowToast(stringMap.iteration_name_limit2);
                    this.errorHintMessage = "迭代名称输入不合法";
                    this.errorStatus.iterationName = true;
                } else if ((newIterationDescription.length > 0 && !(newIterationDescription.match(iterationtitlePattern)))) {
                    uShowToast(stringMap.iteration_description_limit2);
                    this.errorHintMessage = "迭代描述输入不合法";
                    this.errorStatus.iterationDes = true;
                } else if (newIterationName.length > 60) {
                    uShowToast(stringMap.iteration_name_limit3);
                    this.errorHintMessage = "迭代名称不能超过60个字符";
                    this.errorStatus.iterationName = true;
                } else if (newIterationDescription.length > 255) {
                    uShowToast(stringMap.iteration_description_limit1);
                    this.errorHintMessage = "迭代描述不能超过255个字符";
                    this.errorStatus.iterationDes = true;
                } else {
                    uShowLoadingPage();
                    this.errorHintMessage = "";
                    isSaving = true;
                    hCheckIterationName({
                        "project_uuid": project_uuid,
                        "iteration_name": name,
                    }, function (data) {
                        if (data.exist == "true") {
                            uShowToast(stringMap.iteration_name_duplicate);
                            isSaving = false;
                            uHideLoadingPage();
                        } else {
                            self.checkIterationDate(name, des);
                        }


                    }, function (err) {
                        uHideLoadingPage();
                        isSaving = false;
                        uShowAlertDialog(err.reason);
                    });
                }


            },
            checkIterationDate: function (name, des) {
                self = this;
                hCheckIterationDate({
                    "project_uuid": project_uuid,
                    "start_date": new Date(self.startDate).getTime(),
                    "due_date": new Date(self.dueDate).getTime(),
                }, function (data) {
                    if (data.exist == "true") {
                        uShowToast(stringMap.iteration_overlap);
                        isSaving = false;
                        uHideLoadingPage();
                    } else {
                        self.createIteration(name, des);

                    }
                }, function (err) {
                    uHideLoadingPage();
                    isSaving = false;
                    uShowAlertDialog(err.reason);
                });
            },
            createIteration: function (name, des) {
                hCreateIterations({
                    "name": name,
                    "project_uuid": project_uuid,
                    "description": des,
                    "start_date": new Date(self.startDate).getTime(),
                    "due_date": new Date(self.dueDate).getTime(),
                }, function (data) {
                    uHideLoadingPage();
                    //新建迭代成功 刷新迭代列表
                    uSet("needRefreshIteration", "true");
                    uFinishCurrentPage();
                }, function (err) {
                    uHideLoadingPage();
                    uShowAlertDialog(err.reason);
                    isSaving = false;
                });
            },
            addModule: function (moduleName, moduleDes) {
                self = this;
                console.log("+++++++"+this.moduleName);
                if ((moduleName == "")) {
                    uShowToast(stringMap.module_name_limit1);
                } else if ((!(moduleName.match(moduletitlePattern)))) {
                    uShowToast(stringMap.module_name_limit2);
                } else if (moduleName.length > 30) {
                    uShowToast(stringMap.module_name_limit3);
                } else if (moduleDes.length > 0 && (!(moduleDes.match(moduletitlePattern)))) {
                    uShowToast(stringMap.module_description_limit2);
                } else if (moduleDes.length > 255) {
                    uShowToast(stringMap.module_description_limit1);
                } else if (this.moduleName == ""){
                    uShowToast(stringMap.module_person_limit);
                } else {
                    if (isSaving) {
                        return;
                    }
                    isSaving = true;
                    uShowLoadingPage();
                    hCheckModuleName({
                        "project_uuid": project_uuid,
                        "module_name": moduleName,
                    }, function (data) {
                        if (data.exist) {
                            uHideLoadingPage();
                            isSaving = false;
                            uShowToast(stringMap.module_name_duplicate);
                        } else {
                            self.createProjectModule(moduleName, moduleDes);

                        }
                        //新建模块成功 刷新迭代列表
                    }, function (err) {
                        uHideLoadingPage();
                        isSaving = false;
                        uShowAlertDialog(err.reason);
                    });
                }

            },
            createProjectModule: function (name, des) {
                uShowLoadingPage();
                hCreateModule({
                    "project_uuid": project_uuid,
                    "owner": self.owner,
                    "name": name,
                    "description": des
                }, function (data) {
                    uSet("needRefreshModule", "true");
                    uHideLoadingPage();
                    uFinishCurrentPage();
                    //新建模块成功 刷新迭代列表

                }, function (err) {
                    uHideLoadingPage();
                    isSaving = false;
                    uShowAlertDialog(err.reason);
                });
            },
            getUserListByProjectId: function () {
                var self = this;
                hGetUserListByProjectId({
                    "project_uuid": project_uuid
                }, function (data) {
                    userList = data.members;
                    for (var i = 0; i < data.members.length; i++) {
                        for (var j = 0; j < data.members[i].group_members.length; j++) {
                            if (data.members[i].group_members[j].user_id == user_id) {

                                nickname = data.members[i].group_members[j].nickname;
                                name = data.members[i].group_members[j].name;
                                self.moduleName = nickname || name;
                                self.owner = data.members[i].group_members[j].id;
                                self.currentInfo = data.members[i].group_members[j];
                            }
                        }
                    }
                    uHideLoadingPage();
                });
            },
            showItemListPage: function (key) {
                this.listKey = key;
                switch (key) {
                    case 'assigner':
                        uSet("web_view_fragment_title", "选择处理人");
                        uSet("hasSearch", "true");
                        uSet("itemList", JSON.stringify(userList));
                        uSet("searchHint", JSON.stringify(searchHintList["assigner"]));
                        uSet("choosedItem", JSON.stringify(self.currentInfo));

                        break;
                }
                uSet("web_view_fragment_url", "file:///android_asset/page/workItemSubPage/workItemList.html");
                uShowSubPage();
            },
            updateWorkItem: function () {
                if (uGet("choosedItem") && uGet("choosedItem") != "") {
                    var choosedItem = JSON.parse(uGet("choosedItem"));
                    if (this.listKey == 'assigner') {
                        var choosedItemGroup = JSON.parse(uGet("choosedItemGroup"));
                        console.log(choosedItem);
                        console.log(JSON.stringify(choosedItem));
                        console.log(choosedItem.name);

                        nickname = choosedItem.nickname;
                        name = choosedItem.name;
                        self.moduleName = nickname || name;
                        self.owner = choosedItem.id;
                        self.currentInfo = choosedItem;

                    } else {
                    }
                    uSet("choosedItem", "");
                }
            },
            chooseDate: function (date) {
                //判断日期是否合法
                if (this.startDatePicker) {
                    if (new Date(date).getTime() > new Date(this.dueDate).getTime() && formatDateTime(new Date(date), 'yyyy-MM-dd') != formatDateTime(new Date(this.dueDate), 'yyyy-MM-dd')) {
                        uShowToast(stringMap.date_limit1);
                    } else {
                        this.startDate = new Date(date);
                    }
                } else {

                    if (new Date(date).getTime() < new Date(this.startDate).getTime() && formatDateTime(new Date(date), 'yyyy-MM-dd') != formatDateTime(new Date(this.startDate), 'yyyy-MM-dd')) {
                        uShowToast(stringMap.date_limit2);
                    }

                    else {
                        this.dueDate = new Date(date);
                    }
                }
            },
            goTitlePage: function () {
                uGoTitlePage();
            },
            goDesPage: function () {
                uGoDesPage();
            }
        }
    })

}