/**
 * Created by sWX480026 on 2017/6/9.
 */
window.onload = function() {
    var projectUUId = uGet("project_uuid");
    var projectId = uGet("project_id");
    console.log(projectId);
    var projectImageDirectoryPath = "../../theme/image/";
    var vm = new Vue({
        el:'#view-container',
        data:{
            projectInfo : {
                projectName:"",
                projectFollowImage:"../../theme/image/projectManagement-unfollow.png",
                projectDes:"",
                projectModelName:"",
                projectImage:"",
                projectMember:"",
                isFollow:false,
                projectId:""
            },
            hasDescription: false,
            readOnly: false,
            canDelete:false,
            requestDone :false
        },
        created:function(){

        },
        mounted:function(){
            var self = this;
            self.getProjectDetails();
            uSetUpdateProjectListener(function () {
                self.updateProject();
            });
            uSetPublicBackButtonClickListener(function () {
                self.goBack();
            });
        },
        methods:{
            goBack:function () {
                uHideLoadingPage();
                uFinishCurrentPage();
            },
            showProjectEditionPage: function () {
                if (this.readOnly) {
                    return;
                }
                uShowProjectEditionPage();
            },
            likeClick:function(){
                uShowLoadingPage();
                var self = this;
                if (self.projectInfo.isFollow) {
                    hWatchProjectCancel({
                        "project_id": projectId,
                        "type":"un-watch"
                    }, function (data) {
                        self.projectInfo.isFollow = false;
                        self.projectFollowImage = "../../theme/image/projectManagement-unfollow.png";
                        $('#project_setting_like_status_img').attr('src',self.projectFollowImage);
                        uSet("needRequestProject","true");
                        uHideLoadingPage();
                    })
                } else {
                    hWatchProject({
                        "project_id": projectId,
                        "type":"watch"
                    }, function (data) {
                        self.projectInfo.isFollow = true;
                        self.projectFollowImage = "../../theme/image/projectManagement-follow.png";
                        $('#project_setting_like_status_img').attr('src',self.projectFollowImage);
                        uSet("needRequestProject","true");
                        uHideLoadingPage();
                    })
                }
            },
            projectImgClick:function(){
                rProjectImgClick();
            },
            showProjectIterationPage:function(){
                uShowProjectIterationPage();
            },
            showProjectModulePage:function(){
                uShowProjectModulePage();
            },
            showProjectFieldPage:function(){
                console.log("+++++++++++");
                uShowProjectFieldPage();
            },
            showProjectMemberPage:function(){
                uShowMemberPage();
            },
            qrClick:function(){
                uShowQrCodePage();
            },
            authorityClick:function(){
                uShowAuthorityPage();
            },
            getProjectDetails: function () {
                uShowLoadingPage();
                var self = this;
                hGetProjectDetails({
                    "project_uuid": projectUUId
                }, function (data) {
                    var projectInfo = data.project;
                    var role = Number(projectInfo.role);
                    self.requestDone = true;
                    self.readOnly = !((role == ROLE.CREATOR) || (role == ROLE.MANAGER) || (role == ROLE.TESTMANAGER));
                    self.projectInfo.projectName = projectInfo.name;
                    self.projectInfo.projectDes = projectInfo.description;
                    if (self.projectInfo.projectDes != "" && self.projectInfo.projectDes != null) {
                        self.hasDescription = true;
                    }
                    self.projectInfo.projectId = projectInfo.id;
                    self.projectInfo.projectMember = projectInfo.member_count;
                    self.projectInfo.isFollow = projectInfo.is_watch;
                    self.projectFollowImage = projectImageDirectoryPath + (self.projectInfo.isFollow ? "projectManagement-follow.png" : "projectManagement-unfollow.png");
                    self.projectInfo.projectModelName = projectInfo.type == "normal" ? "精简" : "Scrum";
                    uShowSelf();
                    $('#project_setting_like_status_img').attr('src',self.projectFollowImage);
                    uHideLoadingPage();
                });
            },
            updateProject: function () {
                console.log("updateProject");
                this.getProjectDetails();
            }
        }
    })
};