var hCallbackFunctions = {};
var hFileUploadCallbackFunctions = {};
var isAPIGateway = true;

function __hCallback(functionId, data) {
    if (typeof (hCallbackFunctions[functionId]) === "undefined") {
        console.log("__hCallback function: '" + functionId + "' is undefined");
        return;
    }
    if ("hUploadFeedbackAttachments" == functionId.substring(0, 26)) {
        _hUploadFeedbackAttachmentsCallBack(hCallbackFunctions[functionId], functionId.substring(26), data,functionId);
    } else if ("hUploadAttachment" == functionId.substring(0, 17)) {
        _hUploadFeedbackAttachmentsCallBack(hCallbackFunctions[functionId], functionId.substring(17) + "", data,functionId);
    } else {
        _publicCallBack(hCallbackFunctions[functionId], data,functionId);
    }
}

function _publicHttpRequest(functionId, params) {
    if (typeof (Android) !== 'undefined') {
        Android.httpRequest(functionId, JSON.stringify(params));
    } else if (typeof (iOS) !== 'undefined') {
    }
}

function _publicCallBack(callBackFunctions, data, functionId) {
    if (callBackFunctions == null) {
        return;
    }
    console.log(JSON.stringify(data));
    if (isAPIGateway) {
        if (data.status === 'success' && callBackFunctions.success && typeof (callBackFunctions.success) === 'function') {
            console.log("_publicCallBack success");
            callBackFunctions.success(data.result, functionId);
            delete hCallbackFunctions[functionId];
        } else {
            if (data.status === 'error' || 'failed' && data.error) {
                console.log("_publicCallBack error");
                if (callBackFunctions.error && typeof (callBackFunctions.error) === 'function') {
                    callBackFunctions.error(data.error);
                } else {
                    _publicErrorCallback(data.error);
                }
                delete hCallbackFunctions[functionId];
            } else if(data.status === "doing" && data.result) {
                if (callBackFunctions.progress && typeof (callBackFunctions.progress) === 'function') {
                    callBackFunctions.progress(data.result);
                }
            }
        }
    } else {
        if (data.status === 'success' && callBackFunctions.success && typeof (callBackFunctions.success) === 'function') {
            if ((typeof (data.result) !== "undefined") && (typeof (data.result.status) !== "undefined") && (data.result.status === "error")) {
                if (typeof (data.result.error.reason) !== "undefined") {
                    if (typeof (callBackFunctions.error) === "undefined") {
                        _publicErrorCallback(data)
                    } else {
                        callBackFunctions.error(data)
                    }
                } else {
                    if (typeof (callBackFunctions.error) === "undefined") {
                        _publicErrorCallback(data)
                    } else {
                        callBackFunctions.error(data)
                    }
                }
            } else {
                callBackFunctions.success(data);
            }
        } else if (data.status === 'error') {
            if (typeof (callBackFunctions.error) === "undefined") {
                _publicErrorCallback(data)
            } else {
                callBackFunctions.error(data)
            }
        } else {
        }
    }
}

function _publicErrorCallback(data) {
    // TODO: May redirect to the public error page.
    uHideLoadingPage();
    uShowAlertDialog(data.reason);
}

function hGetLoginUser(params, successFun, errorFun) {
    hCallbackFunctions["hGetLoginUser"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetLoginUser", params);
}

function hBetaStatus(params, successFun, errorFun) {
    hCallbackFunctions["hBetaStatus"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hBetaStatus", params);
   var response = {"result":{"result":{"freeQuota":1.0,"status":1.0,"orderStatus":1.0,"betaSwitcher":"on","serviceName":"ProjectMan"},"status":"success"},"error":null,"status":"success"};
   _publicCallBack(hCallbackFunctions["hBetaStatus"], response);
}

function hGetCurrentUserInfo(params, successFun, errorFun) {
    hCallbackFunctions["hGetCurrentUserInfo"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetCurrentUserInfo", params);
}
function hJoinMobileJob(params, successFun, errorFun) {
    hCallbackFunctions["hJoinMobileJob"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hJoinMobileJob", params);
}
function hJoinMobileClass(params, successFun, errorFun) {
    hCallbackFunctions["hJoinMobileClass"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hJoinMobileClass", params);
}
function hGetMobileJobDetail(params, successFun, errorFun) {
    hCallbackFunctions["hGetMobileJobDetail"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetMobileJobDetail", params);
}
function hGetMobileClassDetail(params, successFun, errorFun) {
    hCallbackFunctions["hGetMobileClassDetail"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetMobileClassDetail", params);
}
function hGetMobileClassDetailSummary(params, successFun, errorFun) {
    hCallbackFunctions["hGetMobileClassDetailSummary"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetMobileClassDetailSummary", params);
}
function hGetMyProjects(params, successFun, errorFun) {
    hCallbackFunctions["hGetMyProjects"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetMyProjects", params);
}
function hGetCustomFields(params, successFun, errorFun) {
    hCallbackFunctions["hGetCustomFields"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetCustomFields", params);
}


function hQueryIssue(params, successFun, errorFun) {
    hCallbackFunctions["hQueryIssue"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hQueryIssue", params);
}

function hGetProjectDetails(params, successFun, errorFun) {
    hCallbackFunctions["hGetProjectDetails"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetProjectDetails", params);
}

function hWatchProject(params, successFun, errorFun) {
    hCallbackFunctions["hWatchProject"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hWatchProject", params);
}

function hWatchProjectCancel(params, successFun, errorFun) {
    hCallbackFunctions["hWatchProjectCancel"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hWatchProjectCancel", params);
}

function hDeleteProject(params, successFun, errorFun) {
    hCallbackFunctions["hDeleteProject"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hDeleteProject", params);
}

function hCheckProjectUniqueness(params, successFun, errorFun) {
    hCallbackFunctions["hCheckProjectUniqueness"] = {
        success: successFun,
        error: errorFun
    };
     _publicHttpRequest("hCheckProjectUniqueness", params);
}

function hUpdateProject(params, successFun, errorFun) {
    hCallbackFunctions["hUpdateProject"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hUpdateProject", params);
}

function hCreateProject(params, successFun, errorFun) {
    hCallbackFunctions["hCreateProject"] = {
        success: successFun,
        error: errorFun
    };
     _publicHttpRequest("hCreateProject", params);
}

function hGetAwaitIssuesList(params, successFun, errorFun) {
    hCallbackFunctions["hGetAwaitIssuesList"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetAwaitIssuesList", params);
}

function hWatchIssueCancel(params, successFun, errorFun) {
    hCallbackFunctions["hWatchIssueCancel"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hWatchIssueCancel", params);
}

function hWatchIssue(params, successFun, errorFun) {
    hCallbackFunctions["hWatchIssue"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hWatchIssue", params);
}

function hQueryRootIssue(params, successFun, errorFun) {
    hCallbackFunctions["hQueryRootIssue"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hQueryRootIssue", params);
}

function hGetIssueList(params, successFun, errorFun) {
    hCallbackFunctions["hGetIssueList"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetIssueList", params);
}

function hCreateIssue(params, successFun, errorFun) {
    hCallbackFunctions["hCreateIssue"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hCreateIssue", params);
}

function hQueryProjectTags(params, successFun, errorFun) {
    hCallbackFunctions["hQueryProjectTags"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hQueryProjectTags", params);
}

function hShowIssueDetail(params, successFun, errorFun) {
    hCallbackFunctions["hShowIssueDetail"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hShowIssueDetail", params);
}

function hDeleteIssue(params, successFun, errorFun) {
    hCallbackFunctions["hDeleteIssue"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hDeleteIssue", params);
}

function hUpdateIssue(params, successFun, errorFun) {
    hCallbackFunctions["hUpdateIssue"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hUpdateIssue", params);
}

function hGetModule(params, successFun, errorFun) {
    hCallbackFunctions["hGetModule"] = {
        success: successFun,
        error: errorFun
    };
   _publicHttpRequest("hGetModule", params);
}

function hValidateModuleName(params, successFun, errorFun) {
    hCallbackFunctions["hValidateModuleName"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hValidateModuleName", params);
}

function hUpdateModule(params, successFun, errorFun) {
    hCallbackFunctions["hUpdateModule"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hUpdateModule", params);
}

function hAddModule(params, successFun, errorFun) {
    hCallbackFunctions["hAddModule"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hAddModule", params);
}

function hDeleteModule(params, successFun, errorFun) {
    hCallbackFunctions["hDeleteModule"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hDeleteModule", params);
}

function hGetMilestone(params, successFun, errorFun) {
    hCallbackFunctions["hGetMilestone"] = {
        success: successFun,
        error: errorFun
    };
   _publicHttpRequest("hGetMilestone", params);
}

function hValidateMilestoneName(params, successFun, errorFun) {
    hCallbackFunctions["hValidateMilestoneName"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hValidateMilestoneName", params);
}

function hValidateMilestoneDate(params, successFun, errorFun) {
    hCallbackFunctions["hValidateMilestoneDate"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hValidateMilestoneDate", params);
}

function hCreateMilestone(params, successFun, errorFun) {
    hCallbackFunctions["hCreateMilestone"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hCreateMilestone", params);
}

function hUpdateMilestone(params, successFun, errorFun) {
    hCallbackFunctions["hUpdateMilestone"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hUpdateMilestone", params);
}

function hDeleteMilestone(params, successFun, errorFun) {
    hCallbackFunctions["hDeleteMilestone"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hDeleteMilestone", params);
}

function hGetMilestoneDetails(params, successFun, errorFun) {
    hCallbackFunctions["hGetMilestoneDetails"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetMilestoneDetails", params);
}

function hGetDomain(params, successFun, errorFun) {
    hCallbackFunctions["hGetDomain"] = {
        success: successFun,
        error: errorFun
    };
   _publicHttpRequest("hGetDomain", params);
}

function hAddDomain(params, successFun, errorFun) {
    hCallbackFunctions["hAddDomain"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hAddDomain", params);
}

function hGetSystemDomain(params, successFun, errorFun) {
    hCallbackFunctions["hGetSystemDomain"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetSystemDomain", params);
}

function hDeleteDomain(params, successFun, errorFun) {
    hCallbackFunctions["hDeleteDomain"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hDeleteDomain", params);
}

function hGetApprovedMembers(params, successFun, errorFun) {
    hCallbackFunctions["hGetApprovedMembers"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetApprovedMembers", params);
}

function hApproveMembers(params, successFun, errorFun) {
    hCallbackFunctions["hApproveMembers"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hApproveMembers", params);
}
function hGetUserListByProjectId(params, successFun, errorFun) {
    hCallbackFunctions["hGetUserListByProjectId"] = {
        success: successFun,
        error: errorFun
    };
   _publicHttpRequest("hGetUserListByProjectId", params);
}

function hGrantedTenantVerification(params, successFun, errorFun) {
    hCallbackFunctions["hGrantedTenantVerification"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGrantedTenantVerification", params);
}

function hUserTenantVerification(params, successFun, errorFun) {
    hCallbackFunctions["hUserTenantVerification"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hUserTenantVerification", params);
}

function hTenantInvitation(params, successFun, errorFun) {
    hCallbackFunctions["hTenantInvitation"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hTenantInvitation", params);
}

function hAddMember(params, successFun, errorFun) {
    hCallbackFunctions["hAddMember"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hAddMember", params);
}

function hUserBetaStatus(params, successFun, errorFun) {
    hCallbackFunctions["hUserBetaStatus"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hUserBetaStatus", params);
}

function hGetUserList(params, successFun, errorFun) {
    hCallbackFunctions["hGetUserList"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetUserList", params);
}

function hGetIssueFilter(params, successFun, errorFun) {
    hCallbackFunctions["hGetIssueFilter"] = {
        success: successFun,
        error: errorFun
    };
     _publicHttpRequest("hGetIssueFilter", params);
}

function hCreateFilter(params, successFun, errorFun) {
    hCallbackFunctions["hCreateFilter"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hCreateFilter", params);
}

function hGetServerTime(params, successFun, errorFun) {
    hCallbackFunctions["hGetServerTime"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetServerTime", params);
}



function hSendFeedback(params,successFun,errorFun){
    hCallbackFunctions["hSendFeedback"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hSendFeedback", params);
}

function hGetStatus(params, successFun, errorFun) {
    hCallbackFunctions["hGetStatus"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetStatus", params);
}

function hGetSeverity(params, successFun, errorFun) {
    hCallbackFunctions["hGetSeverity"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetSeverity", params);
}

function hGetIssueRole(params, successFun, errorFun) {
    hCallbackFunctions["hGetIssueRole"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetIssueRole", params);
}

function hValidateAuthor(params, successFun, errorFun) {
    hCallbackFunctions["hValidateAuthor"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hValidateAuthor", params);
}

function hAddAttachmentForWorkItem(src, params, successFun, errorFun) {
    var key = "hAddAttachmentForWorkItem:" + src;
    hCallbackFunctions[key] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest(key, params);
}

function hDeleteAttachmentForWorkItem(src, params, successFun, errorFun) {
    var key = "hDeleteAttachmentForWorkItem:" + src;
    hCallbackFunctions[key] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest(key, params);
}

function hDeleteAttachmentForDocMan(src, params, successFun, errorFun) {
    var key = "hDeleteAttachmentForDocMan:" + src;
    hCallbackFunctions[key] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest(key, params);
}

function _hUploadFeedbackAttachmentsCallBack(callBackFunctions, file, data,functionId) {
    if (data.status === 'success' && callBackFunctions.success && typeof (callBackFunctions.success) === 'function' && data.result) {
        callBackFunctions.success(file, data.result);
        delete hCallbackFunctions[functionId];
    } else {
        if (data.status === 'error' && data.error) {
            if (callBackFunctions.error && typeof (callBackFunctions.error) === 'function') {
                callBackFunctions.error(file, data.error);
            } else {
                _publicErrorCallback(file, data.error);
            }
            delete hCallbackFunctions[functionId];
        } else if(data.status === "doing" && data.result) {
            if (callBackFunctions.progress && typeof (callBackFunctions.progress) === 'function') {
                callBackFunctions.progress(data.result);
            }
        }
    }
}

function hUploadFeedbackAttachments(filename, feedbackId, successFun, errorFun) {
    var key = "hUploadFeedbackAttachments" + filename;
    hCallbackFunctions[key] = {
        success: successFun,
        error: errorFun
    };
    var fileList = [];
    fileList.push({"src": filename});
    if (typeof (Android) !== 'undefined') {
        Android.uploadFile(key, feedbackId, JSON.stringify(fileList));
    } else if (typeof (iOS) !== 'undefined') {
    }
}

function hUploadAttachment(params, successFun, errorFun,progressFun) {
    var key = "hUploadAttachment" + params.fileList[0].src;
    hCallbackFunctions[key] = {
        success: successFun,
        error: errorFun,
        progress:progressFun
    };
    if (typeof (Android) !== 'undefined') {
        Android.uploadAttachment(key, params.project_uuid, params.issue_id, JSON.stringify(params.fileList));
    } else if (typeof (iOS) !== 'undefined') {
    }
}

function hDownloadAttachment(src, params, successFun, errorFun,progressFun) {
    var key = "hDownloadAttachment" + src;
    hCallbackFunctions[key] = {
        success: successFun,
        error: errorFun,
        progress:progressFun
    };
    if (typeof (Android) !== 'undefined') {
        Android.downLoadAttachment(key, params.project_uuid, params.old_project_id, params.business_tag, params.system_type, params.user_agent, params.storefileNames,params.fileNames);
    } else if (typeof (iOS) !== 'undefined') {
    }
}

function hAddCommentForWorkItem(params, successFun, errorFun) {
    hCallbackFunctions["hAddCommentForWorkItem"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hAddCommentForWorkItem", params);
}

function hGetCommentOfWorkItem(params, successFun, errorFun) {
    hCallbackFunctions["hGetCommentOfWorkItem"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetCommentOfWorkItem", params);
}

function hPushComment(params, successFun, errorFun) {
    hCallbackFunctions["hPushComment"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hPushComment", params);
}

function hGetClasses(params, successFun, errorFun) {
    hCallbackFunctions["hGetClasses"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetClasses", params);
}

function hGetJobs(params, successFun, errorFun) {
    hCallbackFunctions["hGetJobs"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetJobs", params);
}

function hWatchClassroom(params, successFun, errorFun) {
    hCallbackFunctions["hWatchClassroom"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hWatchClassroom", params);
}
function hStopReceivingJob(params, successFun, errorFun) {
    hCallbackFunctions["hStopReceivingJob"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hStopReceivingJob", params);
}
function hReceivingJobSchedule(params, successFun, errorFun) {
    hCallbackFunctions["hReceivingJobSchedule"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hReceivingJobSchedule", params);
}
function hGetMobileJobDetailSummary(params, successFun, errorFun) {
    hCallbackFunctions["hGetMobileJobDetailSummary"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetMobileJobDetailSummary", params);
}
function hGetModules(params, successFun, errorFun) {
    hCallbackFunctions["hGetModules"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetModules", params);
}
function hGetIterations(params, successFun, errorFun) {
    hCallbackFunctions["hGetIterations"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetIterations", params);
}
function hUpatateIterations(params, successFun, errorFun) {
    hCallbackFunctions["hUpatateIterations"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hUpatateIterations", params);
}
function hDeleteIteration(params, successFun, errorFun) {
    hCallbackFunctions["hDeleteIteration"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hDeleteIteration", params);
}
function hCreateIterations(params, successFun, errorFun) {
    hCallbackFunctions["hCreateIterations"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hCreateIterations", params);
}
function hGetProjectIterationDetail(params, successFun, errorFun) {
    hCallbackFunctions["hGetProjectIterationDetail"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetProjectIterationDetail", params);
}
function hGetProjectModuleDetail(params, successFun, errorFun) {
    hCallbackFunctions["hGetProjectModuleDetail"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetProjectModuleDetail", params);
}
function hDeleteModule(params, successFun, errorFun) {
    hCallbackFunctions["hDeleteModule"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hDeleteModule", params);
}
function hUpatateModule(params, successFun, errorFun) {
    hCallbackFunctions["hUpatateModule"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hUpatateModule", params);
}
function hCreateModule(params, successFun, errorFun) {
    hCallbackFunctions["hCreateModule"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hCreateModule", params);
}
function hGetDomains(params, successFun, errorFun) {
    hCallbackFunctions["hGetDomains"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetDomains", params);
}
function hGetAllDomains(params, successFun, errorFun) {
    hCallbackFunctions["hGetAllDomains"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetAllDomains", params);
}
function hCloseDomains(params, successFun, errorFun) {
    hCallbackFunctions["hCloseDomains"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hCloseDomains", params);
}
function hOpenDomains(params, successFun, errorFun) {
    hCallbackFunctions["hOpenDomains"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hOpenDomains", params);
}
function hCheckModuleName(params, successFun, errorFun) {
    hCallbackFunctions["hCheckModuleName"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hCheckModuleName", params);
}
function hCheckIterationName(params, successFun, errorFun) {
    hCallbackFunctions["hCheckIterationName"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hCheckIterationName", params);
}
function hCheckIterationDate(params, successFun, errorFun) {
    hCallbackFunctions["hCheckIterationDate"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hCheckIterationDate", params);
}

function hGetFilterConditions(params, successFun, errorFun) {
    hCallbackFunctions["hGetFilterConditions"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetFilterConditions", params);
}

function hQueryIssueSearch(queryValue, params, successFun, errorFun) {
    var key = "hQueryIssueSearch:" + queryValue;
    hCallbackFunctions[key] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest(key, params);
}

function hGetPipelineLog(params, successFun, errorFun) {
    hCallbackFunctions["hGetPipelineLog"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetPipelineLog", params);
}

function hGetIsJobHistoryExist(params, successFun, errorFun) {
    hCallbackFunctions["hGetIsJobHistoryExist"] = {
        success: successFun,
        error: errorFun
    };
    _publicHttpRequest("hGetIsJobHistoryExist", params);
}